﻿Public Class Form1
    Private Sub chkBreakfast_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkBreakfast.CheckedChanged
        ManageCheckGroupBox(chkBreakfast, grpBreakfast)
    End Sub

    Private Sub chkLunch_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkLunch.CheckedChanged
        ManageCheckGroupBox(chkLunch, grpLunch)
    End Sub

    Private Sub ManageCheckGroupBox(ByVal chk As CheckBox, ByVal grp As GroupBox)
        If (grp.Parent Is Nothing) Then Exit Sub
        If (grp.Parent.Controls Is Nothing) Then Exit Sub

        ' Make sure the CheckBox isn't in the GroupBox.
        ' This will only happen the first time.
        If (chk.Parent Is grp) Then
            ' Reparent the CheckBox so it's not in the GroupBox.
            grp.Parent.Controls.Add(chk)

            ' Adjust the CheckBox's location.
            chk.Location = New Point( _
                chk.Left + grp.Left, _
                chk.Top + grp.Top)

            ' Move the CheckBox to the top of the stacking order.
            chk.BringToFront()
        End If

        ' Enable or disable the GroupBox.
        grp.Enabled = (chk.Checked)

        ' Get the appropriate color for the contained controls.
        Dim fore_color As Color
        If (grp.Enabled) Then
            fore_color = Color.FromKnownColor(KnownColor.ActiveCaptionText)
        Else
            fore_color = Color.FromKnownColor(KnownColor.InactiveCaptionText)
        End If

        ' Color the controls in the GroupBox.
        For Each ctl As Control In grp.Controls
            ctl.ForeColor = fore_color
        Next ctl
    End Sub
End Class
